from time import time

import funki.text_colours as tc

φ = lambda x: ('\n' if '\n' in x else '') + f'{x}'

def _duration(t_0):
  period = time()-t_0
  
  if period < 0.5:
    style = tc.success
  elif period > 1:
    style = tc.danger
  else:
    style = tc.warning

  return style(f'{period*1000:.3f} [ms] ')

def fail(name, xyz, mode, time_started):
  print('\n'.join([
    f"\r{tc.danger('FAIL')} {_duration(time_started)} {name}()   ",
    f"{tc.danger('mode:')} {mode}",
    f"{tc.primary('Input       x_args:   ')} {φ(str(xyz['x_args']))}",
    f"{tc.primary('Expectation y_return: ')} {φ(str(xyz['y_return']))}",
    f"{tc.primary('Observation z_return: ')} {φ(str(xyz['z_return']))}",
    f"{tc.secondary('Input       x_stdi: ')} {φ(str(xyz['x_stdi']))}",
    f"{tc.secondary('Expectation y_stdo: ')} {φ(str(xyz['y_stdo']))}",
    f"{tc.secondary('Observation z_stdo: ')} {φ(str(xyz['z_stdo']))}",
  ]))
  return False

def property_failure(name, mode, time_started):
  print('\n'.join([
    f"\r{tc.danger('FAIL')} {_duration(time_started)} {name}()   ",
    f"{tc.danger('mode:')} {mode}",
  ]))
  return False

def success(name, time_started):
  print(f"\r{tc.success('PASS')} {_duration(time_started)} {name}()")
  return True
